#include "burstd.h"

int main(int argc, char **argv)
{
	int 			divIO;
	fd_set			readmask;
	struct sockaddr_in 	sa;
	int 			bytes, oldbytes, addrSize;
	struct ip*		ip;
	void*			buff;
	

	buff = (void *)malloc(IP_MAXPACKET);
	memset((void *)buff, 0, IP_MAXPACKET);
	
	if((divIO = socket(PF_INET, SOCK_RAW, IPPROTO_DIVERT)) == -1)
	{
		perror("socket");
		exit(-1);
	}

	sa.sin_family = AF_INET;
	sa.sin_addr.s_addr = INADDR_ANY;
	sa.sin_port = htons(8670);
	if(bind(divIO, (struct sockaddr*)&sa, sizeof(struct sockaddr)) == -1)
	{
		perror("bind");
		exit(-1);
	}

	FD_ZERO(&readmask);
	FD_SET(divIO, &readmask);
	
	while(1)
	{
		if(select(getdtablesize() + 1, &readmask, NULL, NULL, NULL) == -1)
		{
			perror("select");
			exit(-1);
		}
		if(FD_ISSET(divIO, &readmask))
		{
			addrSize = sizeof(sa);
			if((oldbytes = recvfrom(divIO, buff, IP_MAXPACKET, 0, (struct sockaddr*) &sa, &addrSize)) == -1)
			{
				perror("recvfrom");
				exit(-1);
			}
		
			ip = (struct ip*) buff;
			printf("%s -> %s\n", inet_ntoa(ip->ip_src), inet_ntoa(ip->ip_dst));
			printf("getting %d bytes, real: %d\n", oldbytes, ntohs(ip->ip_len));
			printf("sa.sin_addr.s_addr = %s\n", inet_ntoa(sa.sin_addr));
			
			if((bytes = sendto(divIO, buff, oldbytes, 0, (struct sockaddr*) &sa, addrSize)) != oldbytes)
			{
				printf("Different recieved/sent values: %d <-> %d\n", oldbytes, bytes);
				perror("sendto");
				exit(-1);
			}
		}
	}
	return 0;
}
